Attribute VB_Name = "UrlService"
Option Explicit

Public Function ConvCrLf(ByVal strInBuffer As String)
    Dim lngBufferLenIni As Long, lngBufferLenExt As Long
    Dim lngPtrIn As Long, lngPtrOut As Long
    
    Dim strChar As String
    
    lngBufferLenIni = Len(strInBuffer) * 1.2
    lngBufferLenExt = lngBufferLenIni \ 10
    
    ConvCrLf = Space$(lngBufferLenIni)
    lngPtrIn = 1
    lngPtrOut = 1
    
    Do Until lngPtrIn > Len(strInBuffer)
        
        If lngPtrOut + 2 > Len(ConvCrLf) Then _
            ConvCrLf = ConvCrLf & Space$(lngBufferLenExt)
        
        strChar = Mid$(strInBuffer, lngPtrIn, 1)
        lngPtrIn = lngPtrIn + 1
        
        Select Case strChar
            Case vbCr
                Mid$(ConvCrLf, lngPtrOut, 2) = vbCrLf
                lngPtrOut = lngPtrOut + 2
                
                If Mid$(strInBuffer, lngPtrIn, 1) = vbLf Then _
                    lngPtrIn = lngPtrIn + 1
            
            Case vbLf
                Mid$(ConvCrLf, lngPtrOut, 2) = vbCrLf
                lngPtrOut = lngPtrOut + 2
            
            Case Else
                Mid$(ConvCrLf, lngPtrOut, 1) = strChar
                lngPtrOut = lngPtrOut + 1
        End Select
    Loop
    
    ConvCrLf = Trim$(ConvCrLf)
End Function

Public Function GetTag(Optional ByVal strNewData As String = "") As String
    Dim lngPtrOpen As Long, lngPtrClose As Long, lngTagLen As Long
    Static strBuffer As String, lngPtrBuffer As Long
    
    If strNewData <> "" Then
        strBuffer = strNewData
        lngPtrBuffer = 1
    End If
    If strBuffer = "" Or lngPtrBuffer > Len(strBuffer) Then Exit Function

    lngPtrOpen = InStr(lngPtrBuffer, strBuffer, "<")
    If lngPtrOpen = 0 Then Exit Function
    
    If Mid$(strBuffer, lngPtrBuffer, 4) = "<!--" Then
        lngPtrClose = InStr(lngPtrOpen, strBuffer, "-->")
        If lngPtrClose = 0 Then Exit Function
        lngTagLen = lngPtrClose - lngPtrOpen + 2
    Else
        lngPtrClose = InStr(lngPtrOpen, strBuffer, ">")
        If lngPtrClose = 0 Then Exit Function
        lngTagLen = lngPtrClose - lngPtrOpen + 1
    End If
        
    GetTag = Mid$(strBuffer, lngPtrOpen, lngTagLen)
    lngPtrBuffer = lngPtrClose + 1
End Function

Public Function IsAHrefUrl(ByVal strTag As String) As Boolean
    Dim lngPtrA As Long, lngPtrHREF As Long
    
    If Not (strTag Like "<[Aa]*>") Then     'Proper Tag Fromat?
        IsAHrefUrl = False
    ElseIf InStr(1, strTag, "HREF", vbTextCompare) Then
        IsAHrefUrl = True
    Else
        IsAHrefUrl = False
    End If
End Function

Public Function GetAHrefUrl(ByVal strTag As String) As String
    Dim lngPtrHREF As Long, lngPtrEqual As Long
    Dim lngPtrDQOpen As Long, lngPtrDQClose As Long
    
    '**** Proper Tag Fromat? ****
    If Not (strTag Like "<[aA]*>") Then
        GetAHrefUrl = ""
        Exit Function
    End If
    
    '**** "HREF" Exists? ****
    lngPtrHREF = InStr(1, strTag, "HREF", vbTextCompare)
    If lngPtrHREF = 0 Then
        GetAHrefUrl = ""
        Exit Function
    End If
    
    '**** "=" Exists? ****
    lngPtrEqual = InStr(lngPtrHREF, strTag, "=")
    If lngPtrEqual = 0 Then
        GetAHrefUrl = ""
        Exit Function
    End If
    
    '**** Process After "=" ****
    lngPtrDQOpen = InStr(lngPtrEqual, strTag, """")
    lngPtrDQClose = InStr(lngPtrDQOpen + 1, strTag, """")
    
    If lngPtrDQOpen <> 0 And lngPtrDQClose <> 0 Then
        GetAHrefUrl = Trim$(Mid$(strTag, _
                            lngPtrDQOpen + 1, _
                            lngPtrDQClose - lngPtrDQOpen - 1))
    Else
        GetAHrefUrl = Trim$(Right$(strTag, Len(strTag) - lngPtrEqual))
    End If

End Function

Public Function GetServerName(ByVal strUrl As String) As String
    Dim lngPosSlash As Long
    
    If Not (strUrl Like "http://*") Then    'Proper URL Expression ?
        GetServerName = ""
            
    ElseIf Len(strUrl) = 7 Then             'No Server Name
        GetServerName = ""
    
    Else
        lngPosSlash = InStr(8, strUrl, "/")
        If lngPosSlash = 0 Then                 'Server Name Only
            GetServerName = Mid$(strUrl, 8)
        Else                                    'Server Name and Path
            GetServerName = Mid$(strUrl, 8, lngPosSlash - 8)
        End If
    
    End If
End Function

Public Function GetParentDirUrl(ByVal strUrl As String) As String
    Dim strLastSegment As String, lngPtr As Long

    If Not (strUrl Like "http://*") Then    'Proper URL Expression? ***
        GetParentDirUrl = ""
    
    ElseIf strUrl Like "*/" Then            'Explicitly Indicating Directory with "/" ?
        GetParentDirUrl = strUrl
    
    Else
        lngPtr = Len(strUrl)                'Serach "/" from Right Side
        Do Until Mid$(strUrl, lngPtr, 1) = "/"
            lngPtr = lngPtr - 1
        Loop
        
        If lngPtr = 7 Then                          'Server Name Only
            GetParentDirUrl = strUrl
        Else
            strLastSegment = Mid$(strUrl, lngPtr + 1)
            If InStr(strLastSegment, ".") = 0 Then  'maybe Directory
                GetParentDirUrl = strUrl & "/"
            Else                                    'maybe File Name
                GetParentDirUrl = Left$(strUrl, lngPtr)
            End If
        End If
    End If
End Function

Public Function GetServerUrl(ByVal strUrl As String) As String
    Dim strServerName As String, lngPtr As Long
    
    If Not (strUrl Like "http://*") Then        'Proper URL expression ?
        GetServerUrl = ""
    Else
        strServerName = GetServerName(strUrl)   'Extract Server Name
        If strServerName <> "" Then
            GetServerUrl = "http://" & strServerName & "/"
        Else
            GetServerUrl = ""
        End If
    End If
End Function

Public Function GetFileName(ByVal strUrl As String) As String
    Dim strBuffer As String, lngPtr As Long
    
    If strUrl Like "*/" Then    'Explicitly Indicating Directory with "/" ?
        GetFileName = ""
    Else
        lngPtr = Len(strUrl)    'Serach "/" from Right Side ***
        Do Until Mid$(strUrl, lngPtr, 1) = "/"
            lngPtr = lngPtr - 1
            If lngPtr = 0 Then Exit Do
        Loop
        GetFileName = Right$(strUrl, Len(strUrl) - lngPtr)
    End If
End Function
